//+------------------------------------------------------------------+
//|                                              Ratio_MACDv1_EA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Expert Advisor Builder"
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"

extern int MagicNumber = 0;
extern bool SignalMail = False;
extern bool EachTickMode = False;   
extern bool EachTickMode2 =True;                                   
extern double Lots = 0.1;               
extern int Slippage = 3;                
extern bool UseStopLoss = False;
extern int StopLoss = 30;
extern bool UseTakeProfit = False;
extern int TakeProfit = 60;
extern bool UseTrailingStop = False;
extern int TrailingStop = 30;

extern int    timeFrame     = 15;
extern int    FastEMA       = 6;
extern int    SlowEMA       = 13;
extern int    SignalSMA     =  4;
extern int    applied_price =  6;


extern string  PriceMode    = "";
extern string  _0           = "Close";
extern string  _1           = "Open";
extern string  _2           = "High";
extern string  _3           = "Low";
extern string  _4           = "Median";
extern string  _5           = "Typical";
extern string  _6           = "Weighted Close";
extern string  _7           = "Heiken Ashi Close";
extern string  _8           = "Heiken Ashi Open";
extern string  _9           = "Heiken Ashi High";
extern string  _10          = "Heiken Ashi Low";


int BarCount;
int Current,Current2;
bool TickCheck = False;
bool TickCheck2 = False;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {


   
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;
   if (EachTickMode2) Current2 = 0; else Current = 1;
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   ObjectDelete("ExtMapBuffer2_EA");
   ObjectDelete("ExtMapBuffer2_1_EA");

   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {

   
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   if (EachTickMode2 && Bars != BarCount) TickCheck2 = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+


double Buy1_1 = iCustom(NULL, 0, "@Ratio_MACD_v1",timeFrame,FastEMA,SlowEMA,SignalSMA,applied_price, 1, Current + 0); //ExtMapBuffer2 
double Buy1_2 = iCustom(NULL, 0, "@Ratio_MACD_v1",timeFrame,FastEMA,SlowEMA,SignalSMA,applied_price, 1, Current + 1); //ExtMapBuffer2_1

double Sell1_1 = iCustom(NULL, 0, "@Ratio_MACD_v1",timeFrame,FastEMA,SlowEMA,SignalSMA,applied_price, 1, Current + 0);  
double Sell1_2 = iCustom(NULL, 0, "@Ratio_MACD_v1",timeFrame,FastEMA,SlowEMA,SignalSMA,applied_price, 1, Current + 1);

double CloseBuy1_1 = iCustom(NULL, 0, "@Ratio_MACD_v1",timeFrame,FastEMA,SlowEMA,SignalSMA,applied_price, 1, Current + 0);  
double CloseBuy1_2 = iCustom(NULL, 0, "@Ratio_MACD_v1",timeFrame,FastEMA,SlowEMA,SignalSMA,applied_price, 1, Current + 1);


double CloseSell1_1 = iCustom(NULL, 0, "@Ratio_MACD_v1",timeFrame,FastEMA,SlowEMA,SignalSMA,applied_price, 1, Current + 0);  
double CloseSell1_2 = iCustom(NULL, 0, "@Ratio_MACD_v1",timeFrame,FastEMA,SlowEMA,SignalSMA,applied_price, 1, Current + 1);


   Comment("Ratio Slope , Happy Trading");

   
   ObjectCreate("ExtMapBuffer2_EA",OBJ_LABEL,0,0,0);
   ObjectSet("ExtMapBuffer2_EA",OBJPROP_CORNER,0);   
   ObjectSet("ExtMapBuffer2_EA",OBJPROP_XDISTANCE,15);
   ObjectSet("ExtMapBuffer2_EA",OBJPROP_YDISTANCE,20);
   ObjectSetText("ExtMapBuffer2_EA","ExtMapBuffer2_EA   "+(Buy1_1),10,"Times New Roman",Lime);
   
   ObjectCreate("ExtMapBuffer2_1_EA",OBJ_LABEL,0,0,0);
   ObjectSet("ExtMapBuffer2_1_EA",OBJPROP_CORNER,0);   
   ObjectSet("ExtMapBuffer2_1_EA",OBJPROP_XDISTANCE,15);
   ObjectSet("ExtMapBuffer2_1_EA",OBJPROP_YDISTANCE,35);
   ObjectSetText("ExtMapBuffer2_1_EA","ExtMapBuffer2_1_EA   "+(Buy1_2),10,"Times New Roman",Red);

     
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+
                       if (  CloseBuy1_1 < CloseBuy1_2 ) Order = SIGNAL_CLOSEBUY;
                 
                     
                   
                
            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+
            
                       if (CloseSell1_1 > CloseSell1_2 ) Order = SIGNAL_CLOSESELL;
                    
            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+
          if (Buy1_1 > Buy1_2  ) Order = SIGNAL_BUY;
  
          if ( Sell1_1 < Sell1_2 ) Order = SIGNAL_SELL;
    

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode2 && !TickCheck2) || (!EachTickMode2 && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode2) TickCheck2 = True;
         if (!EachTickMode2) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode2 && !TickCheck2) || (!EachTickMode2 && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode2) TickCheck2 = True;
         if (!EachTickMode2) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;  
   if (!EachTickMode2) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+




